@ECHO OFF
CLS
REM =================================================
REM Please Change Name and Path for the Following Variables
REM =================================================
SETLOCAL ENABLEDELAYEDEXPANSION
call:READINI SETTINGS ZipExe
call:READINI SETTINGS RARExe
call:READINI SETTINGS NFOFile
call:READINI SETTINGS FILEID
call:READINI SETTINGS INTROEXE
call:READINI SETTINGS BASEFILENAME
call:READINI SETTINGS RAROPT
call:READINI SETTINGS RARVOLSIZE
call:READINI SETTINGS RAREXTRA
call:READINI SETTINGS INPUTDATA
call:READINI SETTINGS RARFiles
call:READINI SETTINGS IFFILEEXISTS
Echo ---------------------------------------------------------
Echo ProcRel.INI Parameters
Echo ---------------------------------------------------------
Echo ZipExe=%ZipExe%
Echo RARExe=%RARExe%
Echo NFOFile=%NFOFile%
Echo FILEID=%FILEID%
Echo INTROEXE=%INTROEXE%
Echo BASEFILENAME=%BASEFILENAME%
Echo RAROPT=%RAROPT%
Echo RARVOLSIZE=%RARVOLSIZE%
Echo RAREXTRA=%RAREXTRA%
Echo INPUTDATA=%INPUTDATA%
Echo RARFiles=%RARFiles%
Echo IFFILEEXISTS=%IFFILEEXISTS%
Echo ---------------------------------------------------------
IF NOT EXIST %NFOFile% goto NONFO
IF NOT EXIST %FILEID% goto NODIZ
set /a zipf=0
IF "%IFFILEEXISTS%"=="ABORT" (
   FOR %%Z in (%BASEFILENAME%??.ZIP) DO (
     GOTO ZIPSFOUND
   )
) ELSE (
   Del /Q "%BASEFILENAME%??.zip"
   Echo Delete "%BASEFILENAME%??.zip"
)
Echo Delete "%BASEFILENAME%.part??.rar" (they should not be there though)
DEL /Q "%BASEFILENAME%.part??.rar"
REM =================================================
Echo Create RAR Archives %1.partXX.RAR for Data Selection %2
%RARExe% %RAROPT% -%RARVOLSIZE% %RAREXTRA% "%BASEFILENAME%" "%INPUTDATA%"
REM =================================================
Echo Rename %BASEFILENAME%.partXX.RAR to %BASEFILENAME%xx.RAR
set /a pos=0
For /f %%x in ('dir /on /b "%BASEFILENAME%.part*.rar"') do (
  set /a pos+=1
)
if %pos%==0 goto NORAR
IF NOT EXIST "WORKDIR" MkDir "WORKDIR"
For /L %%n in (1,1,%pos%) do (
  call :RenRAR %BASEFILENAME% %%n
)
Echo.
Echo =================================================
Echo %pos% RAR volumes were created!
Echo =================================================  
Echo Build List of RAR Archives in Folder...
dir /B /A:-D *.RAR >!RARFiles.txt
REM =================================================
Echo Process RAR Archives...
Set REP1=TOTALFILES
IF EXIST "FILE_ID.WRK" DEL /Q "FILE_ID.WRK">NUL
Call:SandR %FILEID% FILE_ID.WRK %REP1% %pos%
SET FCNT=0
Set REP2=CURRENTFILE
FOR /F "delims=|" %%i IN (!RARFiles.txt) DO (
    Echo Processing %%i
    Set /a FCNT+=1
    IF EXIST "FILE_ID.DIZ" DEL "FILE_ID.DIZ">NUL
    Call:SandR FILE_ID.WRK FILE_ID.DIZ %REP2% !FCNT!
    IF EXIST "%%i.ZIP" del "%%i.ZIP">NUL
    DEL /Q WORKDIR\*.*>NUL
    MOVE "%%i" "WORKDIR\%%i">NUL
    IF EXIST "%NFOFile%" COPY "%NFOFile%" WORKDIR\>NUL
    IF EXIST "FILE_ID.DIZ" COPY "FILE_ID.DIZ" WORKDIR\>NUL
    IF EXIST "%INTROEXE%" COPY "%INTROEXE%" WORKDIR\>NUL
     %ZipExe% -a "%%i.ZIP" "WORKDIR\*.*"
    IF "%RARFiles%" == "KEEP" (MOVE WORKDIR\*.RAR>NUL)
    DEL /Q WORKDIR\*.*>NUL
)
REM =================================================
Echo Build List of TEMP ZIP Files...
Dir /b *.RAR.ZIP>!ZIPfiles.txt
REM =================================================
Echo Rename ZIP Files...
REM =================================================
FOR /F "delims=." %%i IN (!ZIPfiles.txt) DO (
    Echo Rename %%i.RAR.ZIP to %%i.ZIP
    IF EXIST "%%i.ZIP" del "%%i.ZIP"
    REN "%%i.RAR.ZIP" "%%i.ZIP"
)
REM =================================================
Echo Deleting TEMP Files...
IF EXIST !ZIPfiles.txt Del /Q !ZIPfiles.txt
IF EXIST !RARfiles.txt Del /Q !RARfiles.txt
IF EXIST "FILE_ID.WRK" DEL /Q "FILE_ID.WRK">NUL
IF EXIST "FILE_ID.DIZ" DEL /Q "FILE_ID.DIZ">NUL
RmDir WORKDIR>NUL
ECHO =================================================
ECHO Done!
ECHO =================================================
Echo.
 Pause
goto END

REM =============================================
REM PROCESSING FUNCTIONS
REM =============================================
:READINI
Set key=%~2
call:strLen key len
Set /a "len+=1"
set yfs=
set ymn=
for /f "tokens=*" %%i in ( ProcRel.ini ) do (
  set ywv=%%i
  if /i "!ywv!"=="[%1]" (
     set yfs=Y
   ) else (
     set ywv=!ywv:~0,%len%!
     if defined yfs (
        if not defined ymn (
          if /i "!ywv!"=="%2=" ( 
            set ymn=%%i
            set ymn=!ymn:~%len%!
          )
        )
     )
   )
)
Set %~2=%ymn%
GOTO :EOF
REM =============================================
:strLen -- returns the length of a str, max 1023
::      -- %~1: in - varible name of a string variable
::      -- %~2: out- string length
SETLOCAL
set str=A!%~1!
set len=0
set /a n=1024
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
set /a n^>^>=1, len+=n
 if !str:~%len%!. == . set /a len-=n
( ENDLOCAL & REM RETURN VALUES
    IF "%~2" NEQ "" SET %~2=%len%
)
GOTO:EOF  
REM =============================================
:SandR
REM Search And Replace
SETLOCAL
for %%i in (%1) do (
  for /f "tokens=1,* delims=]" %%a in ('"type %%i|find /n /v """') do (
    set "line=%%b"
    if defined line (
        call set "line=echo.%%line:%3=%4%%"
        for /f "delims=" %%X in ('"echo."%%line%%""') do %%~X>>%2
    ) ELSE echo.>>%2
)
)
ENDLOCAL
goto :eof
REM =================================================
:RenRAR
IF EXIST "%1.part%2.rar" ( 
     ren "%1.part%2.rar" "%1%2.RAR"
     echo ren "%1.part%2.rar" "%1%2.RAR"
) else (
   IF EXIST "%1.part0%2.rar" ( 
       ren "%1.part0%2.rar" "%10%2.RAR"
       echo ren "%1.part0%2.rar" "%10%2.RAR"
    )
)  
GOTO :EOF

REM =================================================
REM ERROR MESSAGE FUNCTIONS
REM =================================================
:NORAR
echo.
Echo Error!
echo Error! No RAR Archives with the file names
echo %BASEFILENAME%.partXX.RAR
echo were Created!
goto END
REM =================================================
:NONFO
echo.
Echo Error!
echo NFO-File %NFOFile% not found!
goto END
REM =================================================
:NODIZ
echo.
Echo Error!
echo File_ID.DIZ Template File NOT Found at %FILEID%
goto END
REM =================================================
:ZIPSFOUND
echo.
Echo Error! (ABORT Parameter specified)
Echo Current directory contains already one or more ZIP files 
Echo with the name: %BASEFILENAME%??.ZIP 
goto END
REM =================================================
:END
REM Finished!
Echo.
Goto :EOF
